=begin
#Notifo API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

module SwaggerClient
  class AppsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete an app contributor.
    # @param app_id The id of the app.
    # @param contributor_id The contributor to remove.
    # @param [Hash] opts the optional parameters
    # @return [AppDetailsDto]
    def apps_delete_contributor(app_id, contributor_id, opts = {})
      data, _status_code, _headers = apps_delete_contributor_with_http_info(app_id, contributor_id, opts)
      data
    end

    # Delete an app contributor.
    # @param app_id The id of the app.
    # @param contributor_id The contributor to remove.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDetailsDto, Integer, Hash)>] AppDetailsDto data, response status code and response headers
    def apps_delete_contributor_with_http_info(app_id, contributor_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_delete_contributor ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_delete_contributor"
      end
      # verify the required parameter 'contributor_id' is set
      if @api_client.config.client_side_validation && contributor_id.nil?
        fail ArgumentError, "Missing the required parameter 'contributor_id' when calling AppsApi.apps_delete_contributor"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/contributors/{contributorId}'.sub('{' + 'appId' + '}', app_id.to_s).sub('{' + 'contributorId' + '}', contributor_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'AppDetailsDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_delete_contributor\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete an app email template.
    # @param app_id The id of the app where the email templates belong to.
    # @param language The language.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def apps_delete_email_template(app_id, language, opts = {})
      apps_delete_email_template_with_http_info(app_id, language, opts)
      nil
    end

    # Delete an app email template.
    # @param app_id The id of the app where the email templates belong to.
    # @param language The language.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def apps_delete_email_template_with_http_info(app_id, language, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_delete_email_template ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_delete_email_template"
      end
      # verify the required parameter 'language' is set
      if @api_client.config.client_side_validation && language.nil?
        fail ArgumentError, "Missing the required parameter 'language' when calling AppsApi.apps_delete_email_template"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/email-templates/{language}'.sub('{' + 'appId' + '}', app_id.to_s).sub('{' + 'language' + '}', language.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_delete_email_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get app by id.
    # @param app_id The id of the app.
    # @param [Hash] opts the optional parameters
    # @return [AppDetailsDto]
    def apps_get_app(app_id, opts = {})
      data, _status_code, _headers = apps_get_app_with_http_info(app_id, opts)
      data
    end

    # Get app by id.
    # @param app_id The id of the app.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDetailsDto, Integer, Hash)>] AppDetailsDto data, response status code and response headers
    def apps_get_app_with_http_info(app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_get_app ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_get_app"
      end
      # resource path
      local_var_path = '/api/apps/{appId}'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'AppDetailsDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_get_app\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get the user apps.
    # @param [Hash] opts the optional parameters
    # @return [Array<AppDto>]
    def apps_get_apps(opts = {})
      data, _status_code, _headers = apps_get_apps_with_http_info(opts)
      data
    end

    # Get the user apps.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AppDto>, Integer, Hash)>] Array<AppDto> data, response status code and response headers
    def apps_get_apps_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_get_apps ...'
      end
      # resource path
      local_var_path = '/api/apps'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<AppDto>' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_get_apps\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get the app email templates.
    # @param app_id The id of the app where the email templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [EmailTemplatesDto]
    def apps_get_email_templates(app_id, opts = {})
      data, _status_code, _headers = apps_get_email_templates_with_http_info(app_id, opts)
      data
    end

    # Get the app email templates.
    # @param app_id The id of the app where the email templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [Array<(EmailTemplatesDto, Integer, Hash)>] EmailTemplatesDto data, response status code and response headers
    def apps_get_email_templates_with_http_info(app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_get_email_templates ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_get_email_templates"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/email-templates'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'EmailTemplatesDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_get_email_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create an app.
    # @param body The request object.
    # @param [Hash] opts the optional parameters
    # @return [AppDto]
    def apps_post_app(body, opts = {})
      data, _status_code, _headers = apps_post_app_with_http_info(body, opts)
      data
    end

    # Create an app.
    # @param body The request object.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDto, Integer, Hash)>] AppDto data, response status code and response headers
    def apps_post_app_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_post_app ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AppsApi.apps_post_app"
      end
      # resource path
      local_var_path = '/api/apps'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'AppDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_post_app\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add an app contributor.
    # @param body The request object.
    # @param app_id The id of the app.
    # @param [Hash] opts the optional parameters
    # @return [AppDetailsDto]
    def apps_post_contributor(body, app_id, opts = {})
      data, _status_code, _headers = apps_post_contributor_with_http_info(body, app_id, opts)
      data
    end

    # Add an app contributor.
    # @param body The request object.
    # @param app_id The id of the app.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDetailsDto, Integer, Hash)>] AppDetailsDto data, response status code and response headers
    def apps_post_contributor_with_http_info(body, app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_post_contributor ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AppsApi.apps_post_contributor"
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_post_contributor"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/contributors'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'AppDetailsDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_post_contributor\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create an app email template.
    # @param body The request object.
    # @param app_id The id of the app where the email templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [EmailTemplateDto]
    def apps_post_email_template(body, app_id, opts = {})
      data, _status_code, _headers = apps_post_email_template_with_http_info(body, app_id, opts)
      data
    end

    # Create an app email template.
    # @param body The request object.
    # @param app_id The id of the app where the email templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [Array<(EmailTemplateDto, Integer, Hash)>] EmailTemplateDto data, response status code and response headers
    def apps_post_email_template_with_http_info(body, app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_post_email_template ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AppsApi.apps_post_email_template"
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_post_email_template"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/email-templates'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'EmailTemplateDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_post_email_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an app.
    # @param body The request object.
    # @param app_id The app id to update.
    # @param [Hash] opts the optional parameters
    # @return [AppDetailsDto]
    def apps_put_app(body, app_id, opts = {})
      data, _status_code, _headers = apps_put_app_with_http_info(body, app_id, opts)
      data
    end

    # Update an app.
    # @param body The request object.
    # @param app_id The app id to update.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDetailsDto, Integer, Hash)>] AppDetailsDto data, response status code and response headers
    def apps_put_app_with_http_info(body, app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_put_app ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AppsApi.apps_put_app"
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_put_app"
      end
      # resource path
      local_var_path = '/api/apps/{appId}'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'AppDetailsDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_put_app\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an app email template.
    # @param body The request object.
    # @param app_id The id of the app where the email templates belong to.
    # @param language The language.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def apps_put_email_template(body, app_id, language, opts = {})
      apps_put_email_template_with_http_info(body, app_id, language, opts)
      nil
    end

    # Update an app email template.
    # @param body The request object.
    # @param app_id The id of the app where the email templates belong to.
    # @param language The language.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def apps_put_email_template_with_http_info(body, app_id, language, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppsApi.apps_put_email_template ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AppsApi.apps_put_email_template"
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppsApi.apps_put_email_template"
      end
      # verify the required parameter 'language' is set
      if @api_client.config.client_side_validation && language.nil?
        fail ArgumentError, "Missing the required parameter 'language' when calling AppsApi.apps_put_email_template"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/email-templates/{language}'.sub('{' + 'appId' + '}', app_id.to_s).sub('{' + 'language' + '}', language.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppsApi#apps_put_email_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
