=begin
#Notifo API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

module SwaggerClient
  class LogsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Query log entries.
    # @param app_id The app where the log entries belongs to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [ListResponseDtoOfLogEntryDto]
    def logs_get_logs(app_id, opts = {})
      data, _status_code, _headers = logs_get_logs_with_http_info(app_id, opts)
      data
    end

    # Query log entries.
    # @param app_id The app where the log entries belongs to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [Array<(ListResponseDtoOfLogEntryDto, Integer, Hash)>] ListResponseDtoOfLogEntryDto data, response status code and response headers
    def logs_get_logs_with_http_info(app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LogsApi.logs_get_logs ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling LogsApi.logs_get_logs"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/logs'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'take'] = opts[:'take'] if !opts[:'take'].nil?
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'ListResponseDtoOfLogEntryDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LogsApi#logs_get_logs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
