=begin
#Notifo API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

module SwaggerClient
  class TemplatesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a template.
    # @param app_id The app where the templates belong to.
    # @param code The template code to delete.
    # @param [Hash] opts the optional parameters
    # @return [ListResponseDtoOfTemplateDto]
    def templates_delete_template(app_id, code, opts = {})
      data, _status_code, _headers = templates_delete_template_with_http_info(app_id, code, opts)
      data
    end

    # Delete a template.
    # @param app_id The app where the templates belong to.
    # @param code The template code to delete.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ListResponseDtoOfTemplateDto, Integer, Hash)>] ListResponseDtoOfTemplateDto data, response status code and response headers
    def templates_delete_template_with_http_info(app_id, code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TemplatesApi.templates_delete_template ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling TemplatesApi.templates_delete_template"
      end
      # verify the required parameter 'code' is set
      if @api_client.config.client_side_validation && code.nil?
        fail ArgumentError, "Missing the required parameter 'code' when calling TemplatesApi.templates_delete_template"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/templates/{code}'.sub('{' + 'appId' + '}', app_id.to_s).sub('{' + 'code' + '}', code.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'ListResponseDtoOfTemplateDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplatesApi#templates_delete_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Query templates.
    # @param app_id The app where the templates belongs to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [ListResponseDtoOfTemplateDto]
    def templates_get_templates(app_id, opts = {})
      data, _status_code, _headers = templates_get_templates_with_http_info(app_id, opts)
      data
    end

    # Query templates.
    # @param app_id The app where the templates belongs to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [Array<(ListResponseDtoOfTemplateDto, Integer, Hash)>] ListResponseDtoOfTemplateDto data, response status code and response headers
    def templates_get_templates_with_http_info(app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TemplatesApi.templates_get_templates ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling TemplatesApi.templates_get_templates"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/templates'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'take'] = opts[:'take'] if !opts[:'take'].nil?
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'ListResponseDtoOfTemplateDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplatesApi#templates_get_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Upsert templates.
    # @param body The upsert request.
    # @param app_id The app where the templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [Array<TemplateDto>]
    def templates_post_templates(body, app_id, opts = {})
      data, _status_code, _headers = templates_post_templates_with_http_info(body, app_id, opts)
      data
    end

    # Upsert templates.
    # @param body The upsert request.
    # @param app_id The app where the templates belong to.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TemplateDto>, Integer, Hash)>] Array<TemplateDto> data, response status code and response headers
    def templates_post_templates_with_http_info(body, app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TemplatesApi.templates_post_templates ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TemplatesApi.templates_post_templates"
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling TemplatesApi.templates_post_templates"
      end
      # resource path
      local_var_path = '/api/apps/{appId}/templates'.sub('{' + 'appId' + '}', app_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'Array<TemplateDto>' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplatesApi#templates_post_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
