=begin
#Notifo API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

require 'date'

module SwaggerClient
  class EventDto
    # The id of the event.
    attr_accessor :id

    # The topic path.
    attr_accessor :topic

    # A custom id to identity the creator.
    attr_accessor :creator_id

    # The display name.
    attr_accessor :display_name

    # Additional user defined data.
    attr_accessor :data

    # The time when the event has been created.
    attr_accessor :created

    attr_accessor :formatting

    # Notification settings per channel.
    attr_accessor :settings

    # User defined properties.
    attr_accessor :properties

    attr_accessor :scheduling

    # The statistics counters.
    attr_accessor :counters

    # True when silent.
    attr_accessor :silent

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'topic' => :'topic',
        :'creator_id' => :'creatorId',
        :'display_name' => :'displayName',
        :'data' => :'data',
        :'created' => :'created',
        :'formatting' => :'formatting',
        :'settings' => :'settings',
        :'properties' => :'properties',
        :'scheduling' => :'scheduling',
        :'counters' => :'counters',
        :'silent' => :'silent'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'Object',
        :'topic' => :'Object',
        :'creator_id' => :'Object',
        :'display_name' => :'Object',
        :'data' => :'Object',
        :'created' => :'Object',
        :'formatting' => :'Object',
        :'settings' => :'Object',
        :'properties' => :'Object',
        :'scheduling' => :'Object',
        :'counters' => :'Object',
        :'silent' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `SwaggerClient::EventDto` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `SwaggerClient::EventDto`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'topic')
        self.topic = attributes[:'topic']
      end

      if attributes.key?(:'creator_id')
        self.creator_id = attributes[:'creator_id']
      end

      if attributes.key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.key?(:'data')
        self.data = attributes[:'data']
      end

      if attributes.key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.key?(:'formatting')
        self.formatting = attributes[:'formatting']
      end

      if attributes.key?(:'settings')
        if (value = attributes[:'settings']).is_a?(Hash)
          self.settings = value
        end
      end

      if attributes.key?(:'properties')
        if (value = attributes[:'properties']).is_a?(Hash)
          self.properties = value
        end
      end

      if attributes.key?(:'scheduling')
        self.scheduling = attributes[:'scheduling']
      end

      if attributes.key?(:'counters')
        if (value = attributes[:'counters']).is_a?(Hash)
          self.counters = value
        end
      end

      if attributes.key?(:'silent')
        self.silent = attributes[:'silent']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @topic.nil?
        invalid_properties.push('invalid value for "topic", topic cannot be nil.')
      end

      if @display_name.nil?
        invalid_properties.push('invalid value for "display_name", display_name cannot be nil.')
      end

      if @created.nil?
        invalid_properties.push('invalid value for "created", created cannot be nil.')
      end

      if @formatting.nil?
        invalid_properties.push('invalid value for "formatting", formatting cannot be nil.')
      end

      if @settings.nil?
        invalid_properties.push('invalid value for "settings", settings cannot be nil.')
      end

      if @properties.nil?
        invalid_properties.push('invalid value for "properties", properties cannot be nil.')
      end

      if @counters.nil?
        invalid_properties.push('invalid value for "counters", counters cannot be nil.')
      end

      if @silent.nil?
        invalid_properties.push('invalid value for "silent", silent cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @topic.nil?
      return false if @display_name.nil?
      return false if @created.nil?
      return false if @formatting.nil?
      return false if @settings.nil?
      return false if @properties.nil?
      return false if @counters.nil?
      return false if @silent.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          topic == o.topic &&
          creator_id == o.creator_id &&
          display_name == o.display_name &&
          data == o.data &&
          created == o.created &&
          formatting == o.formatting &&
          settings == o.settings &&
          properties == o.properties &&
          scheduling == o.scheduling &&
          counters == o.counters &&
          silent == o.silent
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, topic, creator_id, display_name, data, created, formatting, settings, properties, scheduling, counters, silent].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        SwaggerClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
